原题
编写一个程序,找到两个单链表相交的起始节点。
如下面的两个链表:

在节点 c1 开始相交。
示例 1:

输入: intersectVal = 8, listA = [4,1,8,4,5], listB = [5,0,1,8,4,5], skipA = 2, skipB = 3
输出: Reference of the node with value = 8
输入解释: 相交节点的值为 8 (注意,如果两个列表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [4,1,8,4,5],链表 B 为 [5,0,1,8,4,5]。在 A 中,相交节点前有 2 个节点;在 B 中,相交节点前有 3 个节点。
示例 2:

输入: intersectVal = 2, listA = [0,9,1,2,4], listB = [3,2,4], skipA = 3, skipB = 1
输出: Reference of the node with value = 2
输入解释: 相交节点的值为 2 (注意,如果两个列表相交则不能为 0)。从各自的表头开始算起,链表 A 为 [0,9,1,2,4],链表 B 为 [3,2,4]。在 A 中,相交节点前有 3 个节点;在 B 中,相交节点前有 1 个节点。
示例 3:

输入: intersectVal = 0, listA = [2,6,4], listB = [1,5], skipA = 3, skipB = 2
输出: null
输入解释: 从各自的表头开始算起,链表 A 为 [2,6,4],链表 B 为 [1,5]。由于这两个链表不相交,所以 intersectVal 必须为 0,而 skipA 和 skipB 可以是任意值。
解释:这两个链表不相交,因此返回 null。
注意:
- 如果两个链表没有交点,返回
null
. - 在返回结果后,两个链表仍须保持原有的结构。
- 可假定整个链表结构中没有循环。
- 程序尽量满足 O(n) 时间复杂度,且仅用 O(1) 内存。
解法
思想
- HashSet
依次将获取到的链表元素插入一个HashSet中,返回第一个重复的节点。 - 双指针
两个指针从头走到尾的路径长度之差就是两条路径相交点前的长度之差,获取了这个差之后就可以路径短的让路径长的先走几步,然后同时出发,在相交点相遇。
代码
HashSet:
/**
* Definition for singly-linked list.
* public class ListNode {
* int val;
* ListNode next;
* ListNode(int x) {
* val = x;
* next = null;
* }
* }
*/
public class Solution {
public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
if(headA==null || headB==null) return null;
Set<ListNode> set = new HashSet<ListNode>();
ListNode curA = headA;
ListNode curB = headB;
while(curA!=null){
set.add(curA);
curA = curA.next;
}
while(curB!=null){
if(set.contains(curB))
return curB;
set.add(curB);
curB = curB.next;
}
return null;
}
}
双指针:
/**
* Definition for singly-linked list.
* public class ListNode {
* int val;
* ListNode next;
* ListNode(int x) {
* val = x;
* next = null;
* }
* }
*/
public class Solution {
public ListNode getIntersectionNode(ListNode headA, ListNode headB) {
if(headA == null || headB == null) return null;
if(headA == headB) return headA;
ListNode curA = headA;
ListNode curB = headB;
int countA = 0;
int countB = 0;
//两个指针先一起走一遍
while(curA!=curB && (curA.next!=null || curB.next!=null)){
if(curA.next!=null){
curA = curA.next;
countA++;
}
if(curB.next!=null){
curB = curB.next;
countB++;
}
}
if(curA != curB) return null;
//获取两条路径的长度只差
int step;
ListNode longer;
ListNode near;
if(countA>=countB){
step = countA-countB;
longer = headA;
near = headB;
}else{
step = countB-countA;
longer = headB;
near = headA;
}
//近的让远的先走
while(longer != near){
longer = longer.next;
if(step==0)
near = near.next;
else
step --;
}
return longer;
}
}
原创文章,作者:彭晨涛,如若转载,请注明出处:https://www.codetool.top/article/leetcode160-%e7%9b%b8%e4%ba%a4%e9%93%be%e8%a1%a8/